import { ChangeDetectorRef, EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
export declare const TANJ_TEXT_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR: any;
export declare class TextWidgetChange {
    source: TextWidgetComponent;
    value: string;
    constructor(source: TextWidgetComponent, value: string);
}
export declare class TextWidgetComponent implements ControlValueAccessor, OnChanges, OnInit {
    private changeDetectorRef;
    flex: string;
    flexLayout: string;
    flexLayoutAlign: string;
    value: string;
    valueChange: EventEmitter<string>;
    labelPosition: 'before' | 'after' | 'below';
    disabled: boolean;
    hideLabel: boolean;
    onlyLabel: boolean;
    /**
     * Configuration Fields
     */
    label: string;
    defaultValue: string;
    maxLength: number;
    minLength: number;
    change: EventEmitter<any>;
    onTouched: () => any;
    private controlValueAccessorChangeFn;
    constructor(changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    handleValueChange(value: string): void;
    /**
     * Boilerplate / required for Angular
     *
     */
    private emitChangeEvent;
    writeValue(value: string): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TextWidgetComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TextWidgetComponent, "tanj-text-widget", never, { "value": "value"; "labelPosition": "labelPosition"; "disabled": "disabled"; "hideLabel": "hideLabel"; "onlyLabel": "onlyLabel"; "label": "label"; "defaultValue": "defaultValue"; "maxLength": "maxLength"; "minLength": "minLength"; }, { "valueChange": "valueChange"; "change": "change"; }, never, never, false>;
}
